Bug 232437 - Cannot browse a SMB server with 2000+ shares
Cannot browse a SMB server with 2000+ shares
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: gvfs (Show other bugs)
11
i686 Linux
medium Severity high
: ---
: ---
Assigned To: Tomáš Bžatek
Fedora Extras Quality Assurance
bzcl34nup
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-03-15 11:24 EDT by Bryan Christ
Modified: 2015-03-03 17:31 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-06-28 06:24:18 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Script for making 2000 shares (708 bytes, text/plain)
2009-05-22 05:41 EDT, Tomáš Bžatek
no flags Details

  None (edit)
Description Bryan Christ 2007-03-15 11:24:48 EDT
Description of problem:

When browsing or accessing a SMB server with Nautilus which has more than 2000
shares, gnome-vfs2-daemon begins to consume large amounts of memeory.  (I
stopped it before it consumed 1GB).

Version-Release number of selected component (if applicable):

gnome-python2-gnomevfs-2.16.2-2.fc6
gnome-vfs2-smb-2.16.2-2.fc6
gnome-vfs2-devel-2.16.2-2.fc6
gnome-vfs2-2.16.2-2.fc6

How reproducible:

Every time.

Steps to Reproduce:
1.  Point nautilus to SMB server with 2000 shares using syntax: 
smb://my_large_server
2.  Wait and watch memory consumption
3.  Stop gnome-vfs before OOM killer does something.
  
Actual results:

Large amounts of memory consumed.

Expected results:

Ability to browse server and discover shares.

Additional info:
Comment 1 Bug Zapper 2008-04-04 02:32:33 EDT
Fedora apologizes that these issues have not been resolved yet. We're
sorry it's taken so long for your bug to be properly triaged and acted
on. We appreciate the time you took to report this issue and want to
make sure no important bugs slip through the cracks.

If you're currently running a version of Fedora Core between 1 and 6,
please note that Fedora no longer maintains these releases. We strongly
encourage you to upgrade to a current Fedora release. In order to
refocus our efforts as a project we are flagging all of the open bugs
for releases which are no longer maintained and closing them.
http://fedoraproject.org/wiki/LifeCycle/EOL

If this bug is still open against Fedora Core 1 through 6, thirty days
from now, it will be closed 'WONTFIX'. If you can reporduce this bug in
the latest Fedora version, please change to the respective version. If
you are unable to do this, please add a comment to this bug requesting
the change.

Thanks for your help, and we apologize again that we haven't handled
these issues to this point.

The process we are following is outlined here:
http://fedoraproject.org/wiki/BugZappers/F9CleanUp

We will be following the process here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping to ensure this
doesn't happen again.

And if you'd like to join the bug triage team to help make things
better, check out http://fedoraproject.org/wiki/BugZappers
Comment 2 Bryan Christ 2008-04-04 11:02:04 EDT
The original behavior (excessive memory consumption is gone).  Now a dialog is
displayed saying "The folder contents could not be displayed" or that the share
could not be found.
Comment 3 Bryan Christ 2008-05-16 15:05:24 EDT
Retested with F9 and I still get the error message saying that the folder
contents could not be displayed or that the share could not be found.
Comment 4 Bug Zapper 2008-11-26 02:12:33 EST
This message is a reminder that Fedora 8 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 8.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '8'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 8's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 8 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 5 Bug Zapper 2009-01-08 23:36:02 EST
Fedora 8 changed to end-of-life (EOL) status on 2009-01-07. Fedora 8 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 6 Bryan Christ 2009-01-09 10:55:36 EST
Tomas,

Can you move this to F10 since it is still a problem.
Comment 7 Tomáš Bžatek 2009-01-09 11:08:23 EST
Hi Bryan,

your setup is quite unusual, so I was wondering if you can provide smb.conf from the server where that large number of shares resides. It would help us with debugging. Otherwise I will try to create dumb 2000 shares on some Samba server here.

Also, starting with F9 we've switched to gvfs which has quite different implementation of smb browsing. There are further samba browsing fixes in F10 updates repository: https://admin.fedoraproject.org/updates/F10/FEDORA-2008-11611
Comment 8 Bryan Christ 2009-01-09 11:34:02 EST
Tomas,

The server is a Windows server so there is no smb.conf.  Also, the server is the property of our corporate IT department and I have no authority over it.
Comment 9 Bryan Christ 2009-05-21 12:42:53 EDT
Tomas,

Why did you close this wont fix?
Comment 10 Tomáš Bžatek 2009-05-21 14:17:32 EDT
I didn't, it was Bug Zapper as part of Fedora 8 EOL automation (which is no longer supported and Fedora 9 will be EOL in a month). 

In fact, we don't use gnome-vfs2 anymore, please test this with new (F10 or F11) nautilus and gvfs. Make sure you have all updates.

If this is still a problem, please reopen this bug. I still think there's little we can do but at least we can try.
Comment 11 Bryan Christ 2009-05-21 14:21:45 EDT
Tomas,

I just migrated from F10 to F11 and the problem still persists.  I don't know how to reopen the bug.
Comment 12 Bryan Christ 2009-05-21 14:23:14 EDT
NM.  I just figured out how to reopen and I changed the Version from 8 to rawhide since I am using F11.
Comment 13 Tomáš Bžatek 2009-05-22 05:41:46 EDT
Created attachment 345071 [details]
Script for making 2000 shares

So I've just created 2000 shares (not fake, pointing to real directory) and made a listing in Nautilus and smbclient. Both worked fine with no bigger memory consumption.

F   UID   PID  PPID PRI  NI    VSZ   RSS WCHAN  STAT TTY        TIME COMMAND
0   710 16939     1  20   0 259032  7456 poll_s S+   pts/5      0:00 /usr/libexec/gvfsd-smb-browse --spawner :1.131 /org/gtk/gvfs/exec_spaw/3
(~7.5MB resident size)

Can you please try running `GFS_DEBUG=1 /usr/libexec/gvfsd-smb-browse server=<server> type=smb-server` in gdb, stop at the point it starts eating the memory and attach a backtrace here?

Also, can you please try getting listing using smbclient to find out where the problem is? 
`smbclient -L <server> -d 4`

The only problem I see is that the listing stops after 1529 shares, seems like a limit of smbclient itself (should be reported upstream, not gvfs related).
Comment 14 Bryan Christ 2009-05-22 12:07:03 EDT
I have better luck with smbclient.  I can see all of the directories in the share just fine.
Comment 15 Bryan Christ 2009-05-22 12:09:10 EDT
BTW, even though I can't see the shares in Nautilus (as was first reported), it doesn't appear to be eating memory any more.  The question now is why does smbclient work fine?
Comment 16 Bryan Christ 2009-05-22 12:24:26 EDT
Interestingly, when I mount the share "mount -t cifs" it works and I can see the top level directories, but when I try to change directory into one I get the message "Resource temporarily unavailable".  I think this more closely reflects what's going on with gvfs-smb.
Comment 17 Tomáš Bžatek 2009-06-02 11:28:37 EDT
OK, let's keep the memory consumption issue away.

(In reply to comment #14)
> I have better luck with smbclient.  I can see all of the directories in the
> share just fine.  
Does that mean you were unable to browse 2000 shares or just some directories in one of the 2000 shares?

(In reply to comment #2)
> The original behavior (excessive memory consumption is gone).  Now a dialog is
> displayed saying "The folder contents could not be displayed" or that the share
> could not be found.  
Does this happen when accessing smb://server/ (i.e. listing shares) or when accessing particular share (smb://server/share/)?

The `GFS_DEBUG=1 /usr/libexec/gvfsd -r` command should print out verbose information when browsing smb servers, might be worthwhile to attach the output here.
Comment 18 Bryan Christ 2009-06-03 16:53:50 EDT
I can list the shares just fine with smb://server/

Only when I try to navigate into the share does Nautilus timeout.
Comment 19 Bryan Christ 2009-06-03 16:56:51 EDT
Assuming I understand what you are asking, I copy and paste GFS_DEBUG=1 /usr/libexec/gvfsd -r into a terminal and then try to browse the share with Nautilus.  Nothing appears in the terminal.
Comment 20 Bug Zapper 2009-06-09 05:13:45 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 11 development cycle.
Changing version to '11'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 21 Bug Zapper 2010-04-27 07:41:55 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 22 Bug Zapper 2010-06-28 06:24:18 EDT
Fedora 11 changed to end-of-life (EOL) status on 2010-06-25. Fedora 11 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.